diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/three-gpp-channel-model.h ns-3.44/src/spectrum/model/three-gpp-channel-model.h
--- ns-3.43/src/spectrum/model/three-gpp-channel-model.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/three-gpp-channel-model.h	2025-03-09 16:55:49.695372300 -0700
@@ -13,9 +13,9 @@
 #include "matrix-based-channel-model.h"
 
 #include "ns3/angles.h"
+#include "ns3/boolean.h"
+#include "ns3/channel-condition-model.h"
 #include "ns3/deprecated.h"
-#include <ns3/boolean.h>
-#include <ns3/channel-condition-model.h>
 
 #include <complex.h>
 #include <unordered_map>
@@ -26,13 +26,13 @@
 class MobilityModel;
 
 /**
- * \ingroup spectrum
- * \brief Channel Matrix Generation following 3GPP TR 38.901
+ * @ingroup spectrum
+ * @brief Channel Matrix Generation following 3GPP TR 38.901
  *
  * The class implements the channel matrix generation procedure
  * described in 3GPP TR 38.901.
  *
- * \see GetChannel
+ * @see GetChannel
  */
 class ThreeGppChannelModel : public MatrixBasedChannelModel
 {
@@ -51,43 +51,43 @@
 
     /**
      * Get the type ID
-     * \return the object TypeId
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     /**
      * Set the channel condition model
-     * \param model a pointer to the ChannelConditionModel object
+     * @param model a pointer to the ChannelConditionModel object
      */
     void SetChannelConditionModel(Ptr<ChannelConditionModel> model);
 
     /**
      * Get the associated channel condition model
-     * \return a pointer to the ChannelConditionModel object
+     * @return a pointer to the ChannelConditionModel object
      */
     Ptr<ChannelConditionModel> GetChannelConditionModel() const;
 
     /**
      * Sets the center frequency of the model
-     * \param f the center frequency in Hz
+     * @param f the center frequency in Hz
      */
     void SetFrequency(double f);
 
     /**
      * Returns the center frequency
-     * \return the center frequency in Hz
+     * @return the center frequency in Hz
      */
     double GetFrequency() const;
 
     /**
      * Sets the propagation scenario
-     * \param scenario the propagation scenario
+     * @param scenario the propagation scenario
      */
     void SetScenario(const std::string& scenario);
 
     /**
      * Returns the propagation scenario
-     * \return the propagation scenario
+     * @return the propagation scenario
      */
     std::string GetScenario() const;
 
@@ -97,11 +97,11 @@
      * be updated, it generates a new uncorrelated channel matrix using the
      * method GetNewChannel and updates m_channelMap.
      *
-     * \param aMob mobility model of the a device
-     * \param bMob mobility model of the b device
-     * \param aAntenna antenna of the a device
-     * \param bAntenna antenna of the b device
-     * \return the channel matrix
+     * @param aMob mobility model of the a device
+     * @param bMob mobility model of the b device
+     * @param aAntenna antenna of the a device
+     * @param bAntenna antenna of the b device
+     * @return the channel matrix
      */
     Ptr<const ChannelMatrix> GetChannel(Ptr<const MobilityModel> aMob,
                                         Ptr<const MobilityModel> bMob,
@@ -112,18 +112,18 @@
      * Looks for the channel params associated to the aMob and bMob pair in
      * m_channelParamsMap. If not found it will return a nullptr.
      *
-     * \param aMob mobility model of the a device
-     * \param bMob mobility model of the b device
-     * \return the channel params
+     * @param aMob mobility model of the a device
+     * @param bMob mobility model of the b device
+     * @return the channel params
      */
     Ptr<const ChannelParams> GetParams(Ptr<const MobilityModel> aMob,
                                        Ptr<const MobilityModel> bMob) const override;
     /**
-     * \brief Assign a fixed random variable stream number to the random variables
+     * @brief Assign a fixed random variable stream number to the random variables
      * used by this model.
      *
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this model
+     * @param stream first stream index to use
+     * @return the number of stream indices assigned by this model
      */
     int64_t AssignStreams(int64_t stream);
 
@@ -137,20 +137,13 @@
      * the boundaries of the angle domain, specifically, generating angle distributions
      * close to inclinationRad=0 and inclinationRad=M_PI.
      *
-     * \param azimuthRad the azimuth angle in radians
-     * \param inclinationRad the inclination angle in radians
-     * \return the wrapped (azimuth, inclination) angle pair in radians
+     * @param azimuthRad the azimuth angle in radians
+     * @param inclinationRad the inclination angle in radians
+     * @return the wrapped (azimuth, inclination) angle pair in radians
      */
     static std::pair<double, double> WrapAngles(double azimuthRad, double inclinationRad);
 
     /**
-     * \brief Shuffle the elements of a simple sequence container of type double
-     * \param first Pointer to the first element among the elements to be shuffled
-     * \param last Pointer to the last element among the elements to be shuffled
-     */
-    void Shuffle(double* first, double* last) const;
-
-    /**
      * Extends the struct ChannelParams by including information that is used
      * within the ThreeGppChannelModel class
      */
@@ -235,11 +228,11 @@
 
     /**
      * Get the parameters needed to apply the channel generation procedure
-     * \param channelCondition the channel condition
-     * \param hBS the height of the BS
-     * \param hUT the height of the UT
-     * \param distance2D the 2D distance between tx and rx
-     * \return the parameters table
+     * @param channelCondition the channel condition
+     * @param hBS the height of the BS
+     * @param hUT the height of the UT
+     * @param distance2D the 2D distance between tx and rx
+     * @return the parameters table
      */
     NS_DEPRECATED_3_41("Use GetThreeGppTable(const Ptr<const MobilityModel>, const Ptr<const "
                        "MobilityModel>, Ptr<const ChannelCondition>) instead")
@@ -250,10 +243,10 @@
 
     /**
      * Get the parameters needed to apply the channel generation procedure
-     * \param aMob the mobility model of node A
-     * \param bMob the mobility model of node B
-     * \param channelCondition the channel condition
-     * \return the parameters table
+     * @param aMob the mobility model of node A
+     * @param bMob the mobility model of node B
+     * @param channelCondition the channel condition
+     * @return the parameters table
      */
     virtual Ptr<const ParamsTable> GetThreeGppTable(
         const Ptr<const MobilityModel> aMob,
@@ -275,11 +268,11 @@
      *
      * All relevant generated parameters are added then to ThreeGppChannelParams
      * which is the return value of this function.
-     * \param channelCondition the channel condition
-     * \param table3gpp the 3gpp parameters from the table
-     * \param aMob the a node mobility model
-     * \param bMob the b node mobility model
-     * \return ThreeGppChannelParams structure with all the channel parameters generated
+     * @param channelCondition the channel condition
+     * @param table3gpp the 3gpp parameters from the table
+     * @param aMob the a node mobility model
+     * @param bMob the b node mobility model
+     * @return ThreeGppChannelParams structure with all the channel parameters generated
      * according 38.901 steps from 4 to 10.
      */
     Ptr<ThreeGppChannelParams> GenerateChannelParameters(
@@ -292,14 +285,14 @@
      * Compute the channel matrix between two nodes a and b, and their
      * antenna arrays aAntenna and bAntenna using the procedure
      * described in 3GPP TR 38.901
-     * \param channelParams the channel parameters previously generated for the pair of
+     * @param channelParams the channel parameters previously generated for the pair of
      * nodes a and b
-     * \param table3gpp the 3gpp parameters table
-     * \param sMob the mobility model of node s
-     * \param uMob the mobility model of node u
-     * \param sAntenna the antenna array of node s
-     * \param uAntenna the antenna array of node u
-     * \return the channel realization
+     * @param table3gpp the 3gpp parameters table
+     * @param sMob the mobility model of node s
+     * @param uMob the mobility model of node u
+     * @param sAntenna the antenna array of node s
+     * @param uAntenna the antenna array of node u
+     * @return the channel realization
      */
 
     virtual Ptr<ChannelMatrix> GetNewChannel(Ptr<const ThreeGppChannelParams> channelParams,
@@ -310,10 +303,10 @@
                                              Ptr<const PhasedArrayModel> uAntenna) const;
     /**
      * Applies the blockage model A described in 3GPP TR 38.901
-     * \param channelParams the channel parameters structure
-     * \param clusterAOA vector containing the azimuth angle of arrival for each cluster
-     * \param clusterZOA vector containing the zenith angle of arrival for each cluster
-     * \return vector containing the power attenuation for each cluster
+     * @param channelParams the channel parameters structure
+     * @param clusterAOA vector containing the azimuth angle of arrival for each cluster
+     * @param clusterZOA vector containing the zenith angle of arrival for each cluster
+     * @return vector containing the power attenuation for each cluster
      */
     DoubleVector CalcAttenuationOfBlockage(
         const Ptr<ThreeGppChannelModel::ThreeGppChannelParams> channelParams,
@@ -322,9 +315,9 @@
 
     /**
      * Check if the channel params has to be updated
-     * \param channelParams channel params
-     * \param channelCondition the channel condition
-     * \return true if the channel params has to be updated, false otherwise
+     * @param channelParams channel params
+     * @param channelCondition the channel condition
+     * @return true if the channel params has to be updated, false otherwise
      */
     bool ChannelParamsNeedsUpdate(Ptr<const ThreeGppChannelParams> channelParams,
                                   Ptr<const ChannelCondition> channelCondition) const;
@@ -332,9 +325,9 @@
     /**
      * Check if the channel matrix has to be updated (it needs update when the channel params
      * generation time is more recent than channel matrix generation time
-     * \param channelParams channel params structure
-     * \param channelMatrix channel matrix structure
-     * \return true if the channel matrix has to be updated, false otherwise
+     * @param channelParams channel params structure
+     * @param channelMatrix channel matrix structure
+     * @return true if the channel matrix has to be updated, false otherwise
      */
     bool ChannelMatrixNeedsUpdate(Ptr<const ThreeGppChannelParams> channelParams,
                                   Ptr<const ChannelMatrix> channelMatrix);
@@ -342,10 +335,10 @@
     /**
      * Check if the channel matrix has to be updated due to
      * changes in the number of antenna ports
-     * \param aAntenna the antenna array of node a
-     * \param bAntenna the antenna array of node b
-     * \param channelMatrix channel matrix structure
-     * \return true if the channel matrix has to be updated, false otherwise
+     * @param aAntenna the antenna array of node a
+     * @param bAntenna the antenna array of node b
+     * @param channelMatrix channel matrix structure
+     * @return true if the channel matrix has to be updated, false otherwise
      */
     bool AntennaSetupChanged(Ptr<const PhasedArrayModel> aAntenna,
                              Ptr<const PhasedArrayModel> bAntenna,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc ns-3.44/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc
--- ns-3.43/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2025-03-09 16:55:49.699372300 -0700
@@ -44,7 +44,6 @@
 ThreeGppSpectrumPropagationLossModel::DoDispose()
 {
     m_longTermMap.clear();
-    m_channelModel->Dispose();
     m_channelModel = nullptr;
 }
 
@@ -281,46 +280,52 @@
                                                                numRxPorts,
                                                                isReverse);
 
-    // The precoding matrix is not set
+    NS_ASSERT_MSG(rxParams->psd->GetValuesN() == rxParams->spectrumChannelMatrix->GetNumPages(),
+                  "RX PSD and the spectrum channel matrix should have the same number of RBs ");
+
+    // Calculate RX PSD from the spectrum channel matrix H and
+    // the precoding matrix P as: PSD = (H*P)^h * (H*P)
+    Ptr<const ComplexMatrixArray> p;
     if (!rxParams->precodingMatrix)
     {
-        // Update rxParams->Psd.
-        // Compute RX PSD from the channel matrix
-        auto vit = rxParams->psd->ValuesBegin(); // psd iterator
-        size_t rbIdx = 0;
-        while (vit != rxParams->psd->ValuesEnd())
+        // When the precoding matrix P is not set, we create one with a single column
+        ComplexMatrixArray page =
+            ComplexMatrixArray(rxParams->spectrumChannelMatrix->GetNumCols(), 1, 1);
+        // Initialize it to the inverse square of the number of txPorts
+        page.Elem(0, 0, 0) = 1.0 / sqrt(rxParams->spectrumChannelMatrix->GetNumCols());
+        for (size_t rowI = 0; rowI < rxParams->spectrumChannelMatrix->GetNumCols(); rowI++)
         {
-            // Calculate PSD for the first antenna port (correct for SISO)
-            *vit = std::norm(rxParams->spectrumChannelMatrix->Elem(0, 0, rbIdx));
-            vit++;
-            rbIdx++;
+            page.Elem(rowI, 0, 0) = page.Elem(0, 0, 0);
         }
+        // Replicate vector to match the number of RBGs
+        p = Create<const ComplexMatrixArray>(
+            page.MakeNCopies(rxParams->spectrumChannelMatrix->GetNumPages()));
     }
     else
     {
-        NS_ASSERT_MSG(rxParams->psd->GetValuesN() == rxParams->spectrumChannelMatrix->GetNumPages(),
-                      "RX PSD and the spectrum channel matrix should have the same number of RBs ");
-        // Calculate RX PSD from the spectrum channel matrix, H and
-        // the precoding matrix, P as:
-        // PSD = (H*P)^h * (H*P),
-        // where the dimensions are:
-        // H (rxPorts,txPorts,numRbs) x P (txPorts,txStreams, numRbs) =
-        // HxP (rxPorts,txStreams, numRbs)
-        MatrixBasedChannelModel::Complex3DVector hP =
-            *rxParams->spectrumChannelMatrix * (*rxParams->precodingMatrix);
-        // (HxP)^h dimensions are (txStreams, rxPorts, numRbs)
-        MatrixBasedChannelModel::Complex3DVector hPHerm = hP.HermitianTranspose();
-
-        // Finally, (HxP)^h x (HxP) = PSD (txStreams, txStreams, numRbs)
-        MatrixBasedChannelModel::Complex3DVector psd = hPHerm * hP;
-        // Update rxParams->Psd
-        for (uint32_t rbIdx = 0; rbIdx < rxParams->psd->GetValuesN(); ++rbIdx)
+        p = rxParams->precodingMatrix;
+    }
+    // When we have the precoding matrix P, we first do
+    // H(rxPorts,txPorts,numRbs) x P(txPorts,txStreams,numRbs) = HxP(rxPorts,txStreams,numRbs)
+    MatrixBasedChannelModel::Complex3DVector hP = *rxParams->spectrumChannelMatrix * *p;
+
+    // Then (HxP)^h dimensions are (txStreams, rxPorts, numRbs)
+    // MatrixBasedChannelModel::Complex3DVector hPHerm = hP.HermitianTranspose();
+
+    // Finally, (HxP)^h x (HxP) = PSD(txStreams, txStreams, numRbs)
+    // MatrixBasedChannelModel::Complex3DVector psd = hPHerm * hP;
+
+    // And the received psd is the Trace(PSD).
+    // To avoid wasting computations, we only compute the main diagonal of hPHerm*hP
+    for (uint32_t rbIdx = 0; rbIdx < rxParams->psd->GetValuesN(); ++rbIdx)
+    {
+        (*rxParams->psd)[rbIdx] = 0.0;
+        for (size_t rxPort = 0; rxPort < hP.GetNumRows(); ++rxPort)
         {
-            (*rxParams->psd)[rbIdx] = 0.0;
-
-            for (size_t txStream = 0; txStream < psd.GetNumRows(); ++txStream)
+            for (size_t txStream = 0; txStream < hP.GetNumCols(); ++txStream)
             {
-                (*rxParams->psd)[rbIdx] += std::real(psd(txStream, txStream, rbIdx));
+                (*rxParams->psd)[rbIdx] +=
+                    std::real(std::conj(hP(rxPort, txStream, rbIdx)) * hP(rxPort, txStream, rbIdx));
             }
         }
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h ns-3.44/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h
--- ns-3.43/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2025-03-09 16:55:49.699372300 -0700
@@ -28,8 +28,8 @@
 class NetDevice;
 
 /**
- * \ingroup spectrum
- * \brief 3GPP Spectrum Propagation Loss Model
+ * @ingroup spectrum
+ * @brief 3GPP Spectrum Propagation Loss Model
  *
  * This class models the frequency dependent propagation phenomena in the way
  * described by 3GPP TR 38.901 document. The main method is DoCalcRxPowerSpectralDensity,
@@ -37,9 +37,9 @@
  * the mobility models of the transmitting node and receiving node, and
  * returns the PSD of the received signal.
  *
- * \see MatrixBasedChannelModel
- * \see PhasedArrayModel
- * \see ChannelCondition
+ * @see MatrixBasedChannelModel
+ * @see PhasedArrayModel
+ * @see ChannelCondition
  */
 class ThreeGppSpectrumPropagationLossModel : public PhasedArraySpectrumPropagationLossModel
 {
@@ -61,40 +61,40 @@
 
     /**
      * Get the type ID.
-     * \return the object TypeId
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     /**
      * Set the channel model object
-     * \param channel a pointer to an object implementing the MatrixBasedChannelModel interface
+     * @param channel a pointer to an object implementing the MatrixBasedChannelModel interface
      */
     void SetChannelModel(Ptr<MatrixBasedChannelModel> channel);
 
     /**
      * Get the channel model object
-     * \return a pointer to the object implementing the MatrixBasedChannelModel interface
+     * @return a pointer to the object implementing the MatrixBasedChannelModel interface
      */
     Ptr<MatrixBasedChannelModel> GetChannelModel() const;
 
     /**
      * Sets the value of an attribute belonging to the associated
      * MatrixBasedChannelModel instance
-     * \param name name of the attribute
-     * \param value the attribute value
+     * @param name name of the attribute
+     * @param value the attribute value
      */
     void SetChannelModelAttribute(const std::string& name, const AttributeValue& value);
 
     /**
      * Returns the value of an attribute belonging to the associated
      * MatrixBasedChannelModel instance
-     * \param name name of the attribute
-     * \param value where the result should be stored
+     * @param name name of the attribute
+     * @param value where the result should be stored
      */
     void GetChannelModelAttribute(const std::string& name, AttributeValue& value) const;
 
     /**
-     * \brief Computes the received PSD.
+     * @brief Computes the received PSD.
      *
      * This function computes the received PSD by applying the 3GPP fast fading
      * model and the beamforming gain.
@@ -107,12 +107,12 @@
      * a certain channel is cached and recomputed only when the channel realization
      * is updated, or when the beamforming vectors change.
      *
-     * \param spectrumSignalParams spectrum signal tx parameters
-     * \param a first node mobility model
-     * \param b second node mobility model
-     * \param aPhasedArrayModel the antenna array of the first node
-     * \param bPhasedArrayModel the antenna array of the second node
-     * \return the received PSD
+     * @param spectrumSignalParams spectrum signal tx parameters
+     * @param a first node mobility model
+     * @param b second node mobility model
+     * @param aPhasedArrayModel the antenna array of the first node
+     * @param bPhasedArrayModel the antenna array of the second node
+     * @return the received PSD
      */
     Ptr<SpectrumSignalParameters> DoCalcRxPowerSpectralDensity(
         Ptr<const SpectrumSignalParameters> spectrumSignalParams,
@@ -139,15 +139,15 @@
 
     /**
      * Computes the frequency-domain channel matrix with the dimensions numRxPorts*numTxPorts*numRBs
-     * \param inPsd the input PSD
-     * \param longTerm the long term component
-     * \param channelMatrix the channel matrix structure
-     * \param channelParams the channel parameters, including delays
-     * \param doppler the doppler for each cluster
-     * \param numTxPorts the number of antenna ports at the transmitter
-     * \param numRxPorts the number of antenna ports at the receiver
-     * \param isReverse true if params and longTerm were computed with RX->TX switched
-     * \return 3D spectrum channel matrix with dimensions numRxPorts * numTxPorts * numRBs
+     * @param inPsd the input PSD
+     * @param longTerm the long term component
+     * @param channelMatrix the channel matrix structure
+     * @param channelParams the channel parameters, including delays
+     * @param doppler the doppler for each cluster
+     * @param numTxPorts the number of antenna ports at the transmitter
+     * @param numRxPorts the number of antenna ports at the receiver
+     * @param isReverse true if params and longTerm were computed with RX->TX switched
+     * @return 3D spectrum channel matrix with dimensions numRxPorts * numTxPorts * numRBs
      */
     Ptr<MatrixBasedChannelModel::Complex3DVector> GenSpectrumChannelMatrix(
         Ptr<SpectrumValue> inPsd,
@@ -161,7 +161,7 @@
 
     /**
      * Get the operating frequency
-     * \return the operating frequency in Hz
+     * @return the operating frequency in Hz
      */
     double GetFrequency() const;
 
@@ -169,10 +169,10 @@
      * Looks for the long term component in m_longTermMap. If found, checks
      * whether it has to be updated. If not found or if it has to be updated,
      * calls the method CalcLongTerm to compute it.
-     * \param channelMatrix the channel matrix
-     * \param aPhasedArrayModel the antenna array of the tx device
-     * \param bPhasedArrayModel the antenna array of the rx device
-     * \return vector containing the long term component for each cluster
+     * @param channelMatrix the channel matrix
+     * @param aPhasedArrayModel the antenna array of the tx device
+     * @param bPhasedArrayModel the antenna array of the rx device
+     * @return vector containing the long term component for each cluster
      */
     Ptr<const MatrixBasedChannelModel::Complex3DVector> GetLongTerm(
         Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
@@ -180,10 +180,10 @@
         Ptr<const PhasedArrayModel> bPhasedArrayModel) const;
     /**
      * Computes the long term component
-     * \param channelMatrix the channel matrix H
-     * \param sAnt the pointer to the antenna of the s device
-     * \param uAnt the pointer to the antenna of the u device
-     * \return the long term component
+     * @param channelMatrix the channel matrix H
+     * @param sAnt the pointer to the antenna of the s device
+     * @param uAnt the pointer to the antenna of the u device
+     * @return the long term component
      */
     Ptr<const MatrixBasedChannelModel::Complex3DVector> CalcLongTerm(
         Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
@@ -191,15 +191,15 @@
         Ptr<const PhasedArrayModel> uAnt) const;
 
     /**
-     * \brief Computes a longTerm component from a specific port of s device to the
+     * @brief Computes a longTerm component from a specific port of s device to the
      * specific port of u device and for a specific cluster index
-     * \param params The params that include the channel matrix
-     * \param sAnt pointer to first antenna
-     * \param uAnt uAnt pointer to second antenna
-     * \param sPortIdx the port index of the s device
-     * \param uPortIdx the port index of the u device
-     * \param cIndex the cluster index
-     * \return longTerm component for port pair and for a specific cluster index
+     * @param params The params that include the channel matrix
+     * @param sAnt pointer to first antenna
+     * @param uAnt uAnt pointer to second antenna
+     * @param sPortIdx the port index of the s device
+     * @param uPortIdx the port index of the u device
+     * @param cIndex the cluster index
+     * @return longTerm component for port pair and for a specific cluster index
      */
     std::complex<double> CalculateLongTermComponent(
         Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
@@ -210,17 +210,17 @@
         uint16_t cIndex) const;
 
     /**
-     * \brief Computes the beamforming gain and applies it to the TX PSD
-     * \param params SpectrumSignalParameters holding TX PSD
-     * \param longTerm the long term component
-     * \param channelMatrix the channel matrix structure
-     * \param channelParams the channel params structure
-     * \param sSpeed the speed of the first node
-     * \param uSpeed the speed of the second node
-     * \param numTxPorts the number of the ports of the first node
-     * \param numRxPorts the number of the porst of the second node
-     * \param isReverse indicator that tells whether the channel matrix is reverse
-     * \return
+     * @brief Computes the beamforming gain and applies it to the TX PSD
+     * @param params SpectrumSignalParameters holding TX PSD
+     * @param longTerm the long term component
+     * @param channelMatrix the channel matrix structure
+     * @param channelParams the channel params structure
+     * @param sSpeed the speed of the first node
+     * @param uSpeed the speed of the second node
+     * @param numTxPorts the number of the ports of the first node
+     * @param numRxPorts the number of the porst of the second node
+     * @param isReverse indicator that tells whether the channel matrix is reverse
+     * @return
      */
     Ptr<SpectrumSignalParameters> CalcBeamformingGain(
         Ptr<const SpectrumSignalParameters> params,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/trace-fading-loss-model.cc ns-3.44/src/spectrum/model/trace-fading-loss-model.cc
--- ns-3.43/src/spectrum/model/trace-fading-loss-model.cc	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/trace-fading-loss-model.cc	2025-03-09 16:55:49.699372300 -0700
@@ -12,12 +12,12 @@
 #include "spectrum-signal-parameters.h"
 #include "spectrum-value.h"
 
+#include "ns3/double.h"
+#include "ns3/log.h"
+#include "ns3/mobility-model.h"
+#include "ns3/simulator.h"
+#include "ns3/string.h"
 #include "ns3/uinteger.h"
-#include <ns3/double.h>
-#include <ns3/log.h>
-#include <ns3/mobility-model.h>
-#include <ns3/simulator.h>
-#include <ns3/string.h>
 
 #include <fstream>
 
@@ -57,7 +57,7 @@
                           MakeStringChecker())
             .AddAttribute("TraceLength",
                           "The total length of the fading trace (default value 10 s.)",
-                          TimeValue(Seconds(10.0)),
+                          TimeValue(Seconds(10)),
                           MakeTimeAccessor(&TraceFadingLossModel::SetTraceLength),
                           MakeTimeChecker())
             .AddAttribute("SamplesNum",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/spectrum/model/trace-fading-loss-model.h ns-3.44/src/spectrum/model/trace-fading-loss-model.h
--- ns-3.43/src/spectrum/model/trace-fading-loss-model.h	2024-10-09 16:41:10.088656700 -0700
+++ ns-3.44/src/spectrum/model/trace-fading-loss-model.h	2025-03-09 16:55:49.699372300 -0700
@@ -12,9 +12,9 @@
 
 #include "spectrum-propagation-loss-model.h"
 
+#include "ns3/nstime.h"
+#include "ns3/object.h"
 #include "ns3/random-variable-stream.h"
-#include <ns3/nstime.h>
-#include <ns3/object.h>
 
 #include <map>
 
@@ -24,9 +24,9 @@
 class MobilityModel;
 
 /**
- * \ingroup spectrum
+ * @ingroup spectrum
  *
- * \brief fading loss model based on precalculated fading traces
+ * @brief fading loss model based on precalculated fading traces
  */
 class TraceFadingLossModel : public SpectrumPropagationLossModel
 {
@@ -35,15 +35,15 @@
     ~TraceFadingLossModel() override;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     void DoInitialize() override;
 
     /**
-     * \brief The couple of mobility node that form a fading channel realization
+     * @brief The couple of mobility node that form a fading channel realization
      */
     typedef std::pair<Ptr<const MobilityModel>, Ptr<const MobilityModel>> ChannelRealizationId_t;
 
@@ -53,9 +53,9 @@
   private:
     /**
      * @param params the spectrum signal parameters.
-     * \param a sender mobility
-     * \param b receiver mobility
-     * \return set of values vs frequency representing the received
+     * @param a sender mobility
+     * @param b receiver mobility
+     * @return set of values vs frequency representing the received
      *         power in the same units used for the txPsd parameter.
      */
     Ptr<SpectrumValue> DoCalcRxPowerSpectralDensity(Ptr<const SpectrumSignalParameters> params,
@@ -63,21 +63,21 @@
                                                     Ptr<const MobilityModel> b) const override;
 
     /**
-     * \brief Get the value for a particular sub channel and a given speed
-     * \param subChannel the sub channel for which a value is requested
-     * \param speed the relative speed of the two devices
-     * \return the loss for a particular sub channel
+     * @brief Get the value for a particular sub channel and a given speed
+     * @param subChannel the sub channel for which a value is requested
+     * @param speed the relative speed of the two devices
+     * @return the loss for a particular sub channel
      */
     double GetValue(int subChannel, double speed);
 
     /**
-     * \brief Set the trace file name
-     * \param fileName the trace file
+     * @brief Set the trace file name
+     * @param fileName the trace file
      */
     void SetTraceFileName(std::string fileName);
     /**
-     * \brief Set the trace time
-     * \param t the trace time
+     * @brief Set the trace time
+     * @param t the trace time
      */
     void SetTraceLength(Time t);
 
